-- Home brew lua class implementation

-- Short-circuit if we've already been loaded
if polOO then return end

local function obj_index(obj, key)
   return rawget(obj, key) == nil and obj._class and obj._class[key] or rawget(obj, key)
end

local function class_call(class, ...)
   local obj = {_class = class}
   setmetatable(obj, {__index = obj_index})
   obj:init(...)
   return obj
end

local function Class(...)
   local class = {init = function(...) end, delete = function(...) end}
   for dummy, parent in pairs({...}) do
       for k, v in pairs(parent) do
           class[k] = v
       end
   end
   setmetatable(class, {__call = class_call})
   return class
end


polOO = {Class = Class}
